<?php
/*
All source code copyright and proprietary Melonfire, 2001 and 2002. All content, brand names and trademarks copyright and proprietary Melonfire, 2001 and 2002. All rights reserved. Copyright infringement is a violation of law.

This source code is provided with NO WARRANTY WHATSOEVER. It is produced and meant for illustrative purposes only, and is NOT recommended for use in production environments. 

Read more articles like this one at http://www.melonfire.com/community/columns/trog/ and http://www.melonfire.com/
*/

// functions.php - global functions

// define some constants
// message types
$type = array("text", "multipart", "message", "application", "audio", "image", "video", "other");
// message encodings
$encoding = array("7bit", "8bit", "binary", "base64", "quoted-printable", "other");

// check if email address is valid
function validate_email($val)
{
	if($val != "")
	{
		$pattern = "/^([a-zA-Z0-9])+([\.a-zA-Z0-9_-])*@([a-zA-Z0-9_-])+(\.[a-zA-Z0-9_-]+)+/";
		if(preg_match($pattern, $val))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	else
	{
		return false;
	}
}


// parse message body
function parse($structure)
{
	global $type;
	global $encoding;
	
	// create an array to hold message sections
	$ret = array();
	
	// split structure into parts
	$parts = $structure->parts;
	
	/*
	iterate through parts
	and create an array whose every element
	represents one part
	each element is itself an associative array 
	with keys representing the 
		- part number
		- part type 
		- encoding
		- disposition
		- size
		- filename
	*/
	for($x=0; $x<sizeof($parts); $x++)
	{
		$ret[$x]["pid"] = ($x+1);	
	
		$this = $parts[$x];
	
		// default to text
		if ($this->type == "") { $this->type = 0; }
		$ret[$x]["type"] = $type[$this->type] . "/" . strtolower($this->subtype);	
	
		// default to 7bit
		if ($this->encoding == "") { $this->encoding = 0; }
		$ret[$x]["encoding"] = $encoding[$this->encoding];	
		
		$ret[$x]["size"] = strtolower($this->bytes);	
		
		$ret[$x]["disposition"] = strtolower($this->disposition);	
		
		if (strtolower($this->disposition) == "attachment")
		{
			$params = $this->dparameters;
			foreach ($params as $p)
			{
				if($p->attribute == "FILENAME")
				{
				$ret[$x]["name"] = $p->value;	
				break;			
				}
			}
		}
}

return $ret;
}

// iterate through object returned by parse()
// create a new array holding information only on message attachments
function get_attachments($arr)
{
	for($x=0; $x<sizeof($arr); $x++)
	{
		if($arr[$x]["disposition"] == "attachment")
		{
		$ret[] = $arr[$x];
		}
	}
	return $ret;
}

// remove extraneous stuff from email addresses
// returns an email address stripped of everything but the address itself
function clean_address(&$val, $index)
{
	// clean out whitespace
	$val = trim($val);
	// look for angle braces
	$begin = strrpos($val, "<");
	$end = strrpos($val, ">");
	if ($begin !== false) 
	{
		// return whatever is between the angle braces
		$val = substr($val, ($begin+1), $end-$begin-1);
	}
}
?>
