<?php
/*
All source code copyright and proprietary Melonfire, 2001 and 2002. All content, brand names and trademarks copyright and proprietary Melonfire, 2001 and 2002. All rights reserved. Copyright infringement is a violation of law.

This source code is provided with NO WARRANTY WHATSOEVER. It is produced and meant for illustrative purposes only, and is NOT recommended for use in production environments. 

Read more articles like this one at http://www.melonfire.com/community/columns/trog/ and http://www.melonfire.com/
*/

// send.php - send message

// includes
include("functions.php");

// session check
session_start();
if (!session_is_registered("SESSION"))
{
	header("Location: error.php?ec=2");
	exit;
}

// ensure that at least one field has values 
if (!$to && !$cc && !$bcc)
{
	header("Location: error.php?ec=6");
	exit;
}

// check for valid file if attachment exists
if ($attachment_name && $attachment_size <= 0)
{
	header("Location: error.php?ec=7");
	exit;
}

// append signature to body
$sig = "\r\n--\r\nVisit http://www.melonfire.com/community/columns/trog/ for articles\r\nand tutorials on PHP, Python, Perl, MySQL, JSP and XML\r\n";
$body .= $sig;

// put all addresses into a single string
if($to) { $addresses .= $to . ","; }
if($cc) { $addresses .= $cc . ","; }
if($bcc) { $addresses .= $bcc . ","; }

// split address list into array
$all = split(",", $addresses);

// clean addresses
array_walk($all, "clean_address");

// validate each address further here
for($x=0; $x<sizeof($all); $x++)
{
	if($all[$x] == "")
	{
	continue;
	}

	if(!validate_email($all[$x]))
	{
	header("Location: error.php?ec=8");
	exit;
	}
}

// build message headers
$headers = "From: $from\r\n";

if($cc) { $headers .= "Cc: $cc\r\n"; }
if($bcc) { $headers .= "Bcc: $bcc\r\n"; }

// if attachments exist
if($attachment_name || sizeof($amsg) > 0)
{

// create a MIME boundary string
$boundary = "=====MELONFIRE." . md5(uniqid(time())) . "=====";

// add MIME data to the message headers
$headers .= "MIME-Version:1.0\r\n";
$headers .= "Content-Type: multipart/mixed; \r\n\tboundary=\"$boundary\"\r\n\r\n";

// start building a MIME message
// first part is always the message body
// encode as 7-bit text
$str = "--" . $boundary . "\r\n";
$str .= "Content-Type: text/plain;\r\n\tcharset=\"us-ascii\"\r\n";
$str .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
$str .= "$body\r\n\r\n";


	// if forwarded message, array $amsg[] will exist
	// and contain list of attachments to be forwarded
	if (sizeof($amsg) > 0)
	{
	// open message to be forwarded and parse it to find attachment
	$inbox = @imap_open ("{". $SESSION_MAIL_HOST . "/pop3:110}", $SESSION_USER_NAME, $SESSION_USER_PASS) or header("Location: error.php?ec=3");	
	$structure = imap_fetchstructure($inbox, $id);
	$sections = parse($structure);

		// go through attachment list and message section
		// if a match exists, create a MIME section and import that attachment into the message
		// do this as many times as there are attachments to be included
		for ($x=0; $x<sizeof($amsg); $x++)
		{
			for ($y=0; $y<sizeof($sections); $y++)
			{
				if($amsg[$x] == $sections[$y]["pid"])
				{
				$data = imap_fetchbody($inbox, $id, $sections[$y]["pid"]);
				$str .= "--" . $boundary . "\r\n";
				$str .= "Content-Type: " . $sections[$y]["type"] . ";\r\n\tname=\"" . $sections[$y]["name"] . "\"\r\n";
				$str .= "Content-Transfer-Encoding: base64\r\n";
				$str .= "Content-Disposition: attachment; \r\n\tfilename=\"" . $sections[$y]["name"] . "\"\r\n\r\n";
				$str .= $data . "\r\n";
				}
			}

		}
	}
	
	// if an uploaded attachment exists
	// encode it and attach it as a MIME-encoded section
	if ($attachment_name)
	{
	$fp = fopen($attachment, "rb");
	$data = fread($fp, filesize($attachment));
	$data = chunk_split(base64_encode($data));
	fclose($fp);
	
	// add the MIME data
	$str .= "--" . $boundary . "\r\n";
	$str .= "Content-Type: " . $attachment_type . ";\r\n\tname=\"" . $attachment_name . "\"\r\n";
	$str .= "Content-Transfer-Encoding: base64\r\n";
	$str .= "Content-Disposition: attachment; \r\n\tfilename=\"" . $attachment_name . "\"\r\n\r\n";
	$str .= $data . "\r\n";
	}
	
// all done
// add the final MIME boundary
$str .= "\r\n--$boundary--\r\n";

// assign the contents of $str to $body
// note that the original contents of $body will be lost
$body = $str;
}

// send out the message
if(mail($to, $subject, $body, $headers))
{
	$status = "Your message was successfully sent.";
}
else
{
	$status = "An error occurred while sending your message.";
}
?>
<html>
<head>
</head>
<body bgcolor="White"> 

<?
$title = "Send Message";
include("header.php");
?>

<font face="Verdana" size="-1">
<? echo $status; ?>
<p>
You can now <a href="list.php">return to the message list</a>, or <a href="compose.php">compose another message</a>.
</font>

</body>
</html>
